<template>
    <div>
        <breadcrumb-component title="Gerenciar produtos" :pages="breadPages"/>

        <panel-component title="Editar produto">

            <form-product :formData="formData" :isUpdate="true" :checkGrades="checkGrades"></form-product>

        </panel-component>
    </div>
</template>

<script>
    import FormProductComponent from './FormProductComponent'

    export default {
        props: {
            id: {
                require: true
            }
        },

        components: {
            FormProduct: FormProductComponent
        },

        data() {
            return {
                formData: {},
                checkGrades: [],

                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'products', name: 'Gerenciar produtos', active: false},
                    {link: 'products.edit', name: 'Editar', active: true},
                ]
            }
        },

        created() {
            this.$store.dispatch('loadProduct', this.id)
                .then(response => {
                    response.movimenta_estoque = response.movimenta_estoque ? true : false
                    response.emitir_nf = response.emitir_nf ? true : false
                    response.possui_variacao = response.possui_variacao ? true : false
                    response.possui_juros = response.possui_juros ? true : false
                    response.ativo = response.ativo ? true : false
                    this.addCheckGrades(response.product_grids)
                    response.product_grids = this.addVariation(response.product_grids)
                    if (response.provider_id == null)
                        response.provider_id = ''
                    if (response.codigo_barras == null)
                        response.codigo_barras = ''
                    if (response.observacao == null)
                        response.observacao = ''
                    this.formData = response
                })
                .catch(() => {
                    this.$snotify.error('Produto não encontrado', '404')
                    this.$router.push({name: 'products'})
                })
        },

        methods: {
            addVariation(product_grids) {
                product_grids.forEach((grid) => {
                    let pruductVariation = _.map(grid.variations, (data) => {
                        let variations = {
                            variation_id: data.pivot.variation_id,
                            product_grid_id: data.pivot.product_grid_id,
                            gradeName: data.grid.name,
                            variations: data.grid.variations
                        }
                        return variations
                    })
                    grid.variations = pruductVariation
                })
                return product_grids
            },

            addCheckGrades(product_grids) {
                product_grids.forEach((grid, index) => {
                    if (index == 0) {
                        grid.variations.forEach((variation) => {
                            this.checkGrades.push(variation.grid)
                        })
                    }
                })
            },
        }
    }
</script>